part of viltage;

class Entity {
  int layer;
  Display display;
  List<State> states = new List<State>();
  State state;
  int activeState = 0;
  int x, y;
  List<Collidable> _collidables = new List<Collidable>();
  
  /* streams */
  StreamController _controllerUpdate = new StreamController();
  Stream onUpdate;
  
  Entity(this.layer, this.x, this.y, parentScreen) : super() {
    if(parentScreen is Display) this.display = parentScreen;
    else if(parentScreen is VilTAGE) this.display = parentScreen.display;
    else if(parentScreen is Entity) this.display = parentScreen.display;
    
    display.entities[layer].add(this);
    
    states.add(new State(this));
    state = states[activeState];
  
    onUpdate = _controllerUpdate.stream;
  }
  
  Sprite _sprite = new Sprite();
  
  update(num fps) {
    _controllerUpdate.add(fps);
    
    _sprite.removeChildren();
    _fillSprite(display.viltage);
    
    state = states[activeState];
    _sprite.x = (x - display.viltage.camera.x) * display.viltage.config.boxWidth;
    _sprite.y = (y - display.viltage.camera.y) * display.viltage.config.boxHeight;
  }
  
  remove() {
    display.entities[layer].remove(this);
  }
  
  _fillSprite(VilTAGE viltage) {
    for(int i = 0; i < states[activeState].nodes.length; i++) {
      _sprite.addChild(states[activeState].nodes[i].textField);
    }
  }
  
  /** Binds a Collidable object to this Entity.
   *  An alternative is:
   *     new Collidable(x, y, entity);
   */
  addCollidable(int offsetX, int offsetY) {
    Collidable c = new Collidable(offsetX, offsetY, this);
  }
  
  /** Removes a Collidable from this Entity */
  removeCollidable(Collidable c) {
    _collidables.remove(c);
  }
  
  /** Removes all Collidables from this Entity */
  removeAllCollidables() {
    _collidables.clear();
  }
  
  CharNode createCharNode(int x, int y, String text) => states[activeState].createCharNode(x, y, text);
  List<CharNode> createCharNodeLine(int x, int y, String text, [bool horizontal=true]) => states[activeState].createCharNodeLine(x, y, text, horizontal);
  List<List<CharNode>> createCharNodeRect(int x, int y, List<String> text) => states[activeState].createCharNodeRect(x, y, text);
}