library viltage;
import 'dart:html';
import 'dart:html' as HTML;
import 'package:stagexl/stagexl.dart';
import 'dart:async';

part 'viltage_config.dart';
part 'entity.dart';
part 'display.dart';
part 'input.dart';
part 'char_node.dart';
part 'state.dart';
part 'efactory.dart';
part 'collidable.dart';
part 'camera.dart';

class VilTAGE {
  VilTAGEConfig config;
  Input input;
  RenderLoop renderLoop;
  Display display;
  Camera camera;
  
  /* streams */
  StreamController _controllerUpdate = new StreamController();
  Stream onUpdate;
  
  VilTAGE(this.config) {
    renderLoop = new RenderLoop();
    display = new Display(this);
    input = new Input();
    config._calc();
    camera = new Camera();
    
    onUpdate = _controllerUpdate.stream;
  }
  
  setDisplay(Display newScreen) {
    display.remove();
    renderLoop.removeStage(display);
    renderLoop.addStage(newScreen);
    display = newScreen;
    newScreen.show();
    newScreen.focus = newScreen;
    display.onEnterFrame.listen((EnterFrameEvent e) {
      update(display.frameRate);
      display.update(display.frameRate);
    });
  }
  
  update(num fps) {
    input.update();
    _controllerUpdate.add(fps);
  }
}